/* this is the sreLite2 installation program */

call init_it
crlf='0d0a'x

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "This is the sreLite2  (v 1.12) installation program (26 Dec 2002)."
call lineout, "... an http/1.1 compliant filter for the SRE2003 OS/2 Internet Server "
call lineout, normal


say " This program will ask for the names of a few directories,"
say " and will copy a number of files to these directories."
say "  "


aa=yesno(' Would you like to: ','Exit Continue View_Documentation','C')
if aa=0 then do
 say " See you later?.. "
 exit
end
if aa=2 then do
    say " Okay, viewing the sreLite2 manual ... "
     '@START  "The sreLite2 Manual" /C /F /WIN NETSCAPE FILE:///SRELITE2.HTM'
    say ' '
end

/* check status of sre2003 and macrospace routines */
a=dospidlist(l1,l2)
do mm=1 to a
 foo=upper(strip(filespec('n',l2.mm)))
 if foo='SRE2003' then do
     say bold " SRE2003 appears to be running " normal 
     say "(process list has: "l2.mm ')'
     say " Please shut down SRE2003 before you (re) install sreLite2! "
     exit
  end  /* Do */
end /* do */

/* check status of sre2003 and macrospace routines */
a=dosswitchlist(l2)
do mm=1 to a
 foo=upper(strip(filespec('n',l2.mm)))
 if pos('SRE2003',foo)>0 then do
     say bold " SRE2003 appears to be running " normal
     say "(switchlist has: "l2.mm ')'
     say " Please shut down SRE2003 before you (re) install sreLite2! "
     exit
  end  /* Do */
end /* do */

call check_macro

is_upgrade=yesno(normal" Is this a: "bold" New installation (N), or an upgrade (U)",'New Upgrade')


adir=filespec("drive",nowdir)
defname=adir||'\SRE2003'
defname2=adir||'\WWW'

/* -------- Working directory (must exist ) */
call make_def_dirs



/* -- Done with directory creation -- copy files ... */

/* but first, backup? */
aa=sysfiletree(Srelite2_dir'\SRELITE2.RXX','goo','F')
if is_upgrade=1 & goo.0=0 then do         /*check for prior version */
      say bold"ERROR: "normal" Prior version of sreLite2 "bold"not"normal" detected! "
      exit
end

if goo.0>0  then do
 say " "
 foo=yesno(normal" "re_wh"Would you like to archive the various configuration files")
 if foo=1 then do
      say  " Where should sreLite2 archive these files"
      aa="\BK"||space(translate(date('o'),' ','/\'),0)
      backup_dir=get_dir(srelite2_dir||aa)

/* files to backup*/
      in_workdir='NOTFOUND.SHT  SRELITE2.RXX SREL_INI.RXX MTCHFILE.CMD  POSTFILT.CMD '
      in_cfgdir=' USERS.IN SRELITE2.CFG  '
      in_helpdir='INDEX.SHT '
      in_adddir=' '
      call dobackup
      yooba=sysfiletree(srelite2_dir||'\BK*','goos','OD')
      if goos.0>1  then do
          say bold' Reminder:'normal' you have 'goos.0 ' sreLite2 archive directories; you might  '
          say     '          want to remove some of the older ones. '
      end /* do */
 end
end

if is_upgrade=0 then
  foo=yesno(" sreLite2 will now be installed. Are you ready? ")
else
  foo=yesno(" sreLite2 will now be upgraded. Are you ready? ")

if foo=0 then do
  say " Try again later ??? "
  exit
end

say " "
say " Copying dynamic link libraries and helper executables .. "
if gotrxlib=1 then do
   say " Note: a copy of REXXLIB seems to be on your system "
end  /* Do */

say " Copying sreLite2 program files files to " srelite2_dir
foo=check_copy('MTCHFILE.CMD' ,srelite2_dir,,1) 
foo=check_copy('POSTFILT.CMD' ,srelite2_dir,,1) 

foo=check_copy('*.RXX',srelite2_dir,,1)
foo=check_copy('SRELITE2.RXL',srelite2_dir,,1)
foo=check_copy('SRELITE2.IDX',srelite2_dir,,1)
foo=check_copy('SREL2PRC.ZIP',srelite2_dir,,1)

if is_upgrade=0 then do
  foo=check_copy('NOTFOUND.SHT',srelite2_dir,'This is the sample "not found" documents file',1)

  say " Copying configuration files "
  foo=check_copy('USERS.IN',cfgdir,'Are you sure (this is the username/password file')
  foo=check_copy('SRELITE2.CFG',cfgdir,'Are you sure (this is the configuration file)')
end

say " Copying sample files to " helpdir
foo=check_COPY('INDEX.SHT',helpdir,,1)
/* 'This is a sample home-page, with links to sreLite2 examples',foo1) */
foo=check_COPY('CONFIG.HTM',helpdir,,1)
foo=check_COPY('SRECFG1.HTM',helpdir,,1)

foo=check_COPY('READ.ME',helpdir,,1)

foo1=check_COPY('TSTHTTPD.SHT',helpdir,,1)
foo=checK_COPY('SAMPMAP.*',helpdir,,foo1)
foo=check_COPY('*.DOC',helpdir,,foo1)
foo=check_COPY('SRELITE2.HTM',helpdir,,foo1)
foo=check_copy('MULTSEND.CMD',helpdir,,foo1)

foo=check_copy('SRELITE2.GIF',gifdir,,1)
foo=check_copy('SC*.GIF',gifdir,,1)

say " Copying sample CGI-Bin scripts to " cgibin_dir
foo=check_copy('XCOUNT.CMD',cgibin_dir,,foo1)
foo=check_copy('JCOUNT.CMD',cgibin_dir,,foo1)
foo=check_copy('TEST-CGI.CMD',cgibin_dir,,foo1)
foo=check_copy('TXTCLOCK.PL',cgibin_dir,,foo1)

say " Copying sample addons to " addon_dir
foo=check_copy('MAPIMAGE.CMD',addon_dir,,1)
foo=check_copy('STATUSL.CMD',addon_dir,,1)
foo=check_copy('MULTSEND.CMD',addon_dir,,1)
foo=check_copy('TASKDEMO.ZIP',addon_dir,,1)

say "Copying configuration & system tools to " sysaddon_dir
foo=check_copy('USERCFG.CMD',sysaddon_dir,,1)
foo=check_copy('OPTSCFG.CMD',sysaddon_dir,,1)
foo=check_copy('SRE2KCFG.CMD',sysaddon_dir,,1)
foo=check_copy('HOSTCFG.CMD',sysaddon_dir,,1)
foo=check_copy('BADIPCFG.CMD',sysaddon_dir,,1)

foo=check_copy('EDIT-LITE2.CMD',godir,,1)

oo=sysfiletree('*.CM_','cms','FO')
do mm=1 to cms.0
   parse var cms.mm afile '.' .
   afile=afile||'.CMD'
   tofile=sysaddon_dir||'\'||filespec('n',afile)
   foo=check_copy(cms.mm,tofile,,1)
end



meis=directory()


dufus:
say " "

if is_upgrade=0 then do
  call lineout, cy_ye ' ------------ Configuration: ' normal
  say " "
/* now modify sre2003.cfg */
  cfg1=stream(workdir||'\CFG\SRE2003.CFG','c','query exists')
  cfg1t=''
  if cfg1<>''  then do
    tt=workdir||'\CFG\OLD\SRE2003.???'
    cfg1t=dostempname(tt)
    do forever
     ii=yesno("Modify currently existing version of SRE2003.CFG ",'No Yes ?','?')
     if ii=2 then do
       say bold"YES"normal"  SRE2003 will be instructed to use the sreLite2 filter"
       say "     This is accomplished by modifying the working version of SRE2003.cfg"
       say "     ("cfg1")"
       say "     Note that the current version will be backed up "
       say '     (to 'cfg1t')'
       say bold"NO "normal"  You will have to make changes to SRE2003.CFG."
       say '     In particular, you will need to set the values of several parameters:'
       say'         DATADIR, FILTER, FILTER_VERSION, INIT_PROC, and EXIT_PROC.'

    end 
    else do             /* yes no */
      leave
    end
   end           /* do forever (yes no) */
 end            /* SRE2003.cfg exists */
 else do             /* if here, no SRE2003.cfg file */
   say "Setting up SRE2003.CFG "
   ii=1
 end 
 if ii=1 then call modify_cfg cfg1
  say " "

/* -- add entry to users.in file */
  foo=add_user(cfgdir)
  say " "
end

/* -- add to ADD_PLUG.DAT */
if is_upgrade<>1 then foo=add_plug(workdir||'\CFG')

done1: nop


call charout , cy_ye ' (hit any key to continue) ' normal
foo=sysgetkey("noecho")

done1A: nop

a=scrclear()

call lineout, bold cy_ye  " sreLite2 has been installed... " normal
say " "
say ' Your web site is now ready to be built!  '
say '      (just add documents, images, links, etc...)'
say ' '
say ' Notes:'
say '    * SRELITE2.CFG (in 'cfgdir') contains several customization '
say '      (and access control) parameters.  You can edit it with any text editor.'

gog= '    * USERS.IN (in 'cfgdir')'
call charout, gog
gog2='contains username/password information.'
if length(gog||gog2)>80 then do
  say
  say '     ' gog2
end
else do
   call charout, gog2
   say
end 

say '    * SRELITE2.HTM (in 'helpdir') is the sreLite2 manual'
say '    * INDEX.SHT (in 'helpdir') contains links to sample documents, '
say '      and links to configuration tools.'
say '    * 'bold'Upgraders Note:'normal' If you modified advanced-user options in SRELITE2.RXX'
say '      (and elsewhere), you will need to re-enter those changes. '

exit

/********/
modify_cfg:
parse arg oldcfg
if oldcfg='' then oldcfg=stream('SRE2003.CF_','c','query exists')
if oldcfg='' then do
   say "ERROR: unable to find SRE2003.CF_"
   say "Perhaps the distribution file for sreLite2 is corrupted? "
   exit
end 

iff=stream(oldcfg,'c','query size')
stuff=charin(oldcfg,1,iff)
goo=stream(oldcfg,'c','close')

if cfg1t<>'' then do          /* rename prior version? */
  foo=dosrename(oldcfg,cfg1t)
  if foo=0 then do
      say "ERROR: unable to rename old version of SRE2003.CFG "
      say        "(" cfg1t ")"
      exit
   end
  else do
      say "Old version of SRE2003.CFG renamed to: "cfg1t
  end 
end

/* now set
   DATADIR
   FILTER
   FILTER_VERSION
   INIT_PROOC
   EXIT_PROC
*/
newstuff=''
do forever
   if stuff='' then leave
   parse var stuff aline '0d0a'x stuff ; aline=strip(aline)
   if aline='' |  abbrev(aline,';')=1 then do
       newstuff=newstuff||aline||'0d0a'x
       iterate
   end

   parse var aline avar '=' aval
   avar=strip(translate(avar))

   select
      when avar='DATADIR' then do
          newstuff=newstuff||'datadir='||datadir||'0d0a'x
      end 
      when avar='FILTER' then do    
          newstuff=newstuff||'FILTER=srelite2\srelite2.rxx'||'0d0a'x
      end 
      when avar='FILTER_VERSION' then do
          newstuff=newstuff||'FILTER_VERSION=sreLite2 ver 1.12a'||'0d0a'x
      end
      when avar='INIT_PROC' then do
          newstuff=newstuff||'init_proc=bin\inithost.rxx,srelite2\SREL_INI.RXX'||'0d0a'x
      end
      when avar='EXIT_PROC' then do
          newstuff=newstuff||'exit_proc=srelite2\srelexit.rxx'||'0d0a'x
      end
      otherwise do
         newstuff=newstuff||aline||'0d0a'x
      end
   end  /* select */
end /* do forever */


cfg1=workdir||'\CFG\SRE2003.CFG'
foo=sysfiledelete(cfg1)

oo=charout(cfg1,newstuff,1)
foo=stream(cfg1,'c','close')
say "Done writing to " cfg1 
return ' '

/********/
/* copy files to backup directory  */
dobackup:

do mm=1 to words(in_workdir)
     a1=strip(word(in_workdir,mm))
     cto=backup_dir||'\'||a1
     cfrom=srelite2_dir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Archiving ' cfrom ' ... '
         'COPY 'cfrom ' ' cto ' > nul '
     end  /* Do */

end /* do */
do mm=1 to words(in_cfgdir)
     a1=strip(word(in_cfgdir,mm))
     cto=backup_dir||'\'||a1
     cfrom=cfgdir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Archiving ' cfrom ' ... '
         'COPY 'cfrom ' ' cto  ' > nul '
     end
end /* do */

do mm=1 to words(in_helpdir)
     a1=strip(word(in_helpdir,mm))
     cto=backup_dir||'\'||a1
     cfrom=helpdir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Copying ' cfrom ' ... '
         'COPY 'cfrom ' ' cto  ' > nul '
     end
end /* do */

do mm=1 to words(in_adddir)
     a1=strip(word(in_adddir,mm))
     cto=backup_dir||'\'||a1
     cfrom=addon_dir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Copying ' cfrom ' ... '
         'COPY 'cfrom ' ' cto  ' > nul '
     end
end /* do */



return 0


/*****************/
/* Add a record  to the add_plug.dat file */
add_plug:procedure expose ipaddr expose reverse bold normal re_wh cy_ye aesc

parse arg cfgdir

/* read users.in, append uname pwd , write it*/
afile=strip(cfgdir,'t','\')||'\ADD_PLUG.DAT'

oof='0d0a0d0a'x
oof=oof||'Name: The sreLite2 Filter '||'0d0a'x
oof=oof||'Desc: sreLite2 is a moderately featured, but relatively small, filter for SRE2003.'||'0d0a'x
oof=oof||'Desc: This will select sreLite2 with several defaults (any other currently active '||'0d0a'x
oof=oof||'Desc: plugins will be deselected)'||'0d0a'x

oof=oof||'Item: Filter srelite2\srelite2.rxx '||'0d0a'x
oof=oof||'Item: Filter_Version sreLite2 ver 1.12a '||'0d0a'x
oof=oof||'Item: Fast_Filter 0 '||'0d0a'x
oof=oof||'Item: INIT_PROC bin\inithost.rxx, srelite2\SREL_INI.RXX '||'0d0a'x
oof=oof||'Item: EXIT_PROC srelite2\srelexit.rxx '||'0d0a'x
oof=oof||'Item: PRE_Transaction bin\badips.rxx  '||'0d0a'x
oof=oof||'Item: PRE_Request 0  '||'0d0a'x
oof=oof||'Item: IM_TYPES XRANGE bin\im\xrange.rxx '||'0d0a'x
oof=oof||'Item: IM_DEFAULT Range '||'0d0a0d0a'x

foo=append_file(afile,oof,2,1)
if foo<0 then 
  say 'Error ('foo') adding to 'afile
else
  say "sreLite2 installation record added to " afile

return 1

/*****************/
/* Add an entry to the users.in file */
add_user:procedure expose ipaddr expose reverse bold normal re_wh cy_ye aesc

parse arg cfgdir

say " "
say  bold " Add a SUPERUSER to the UserName database " normal
say " "
say ' To facilitate resetting parameters, and other such actions, we recommend that '
say ' you add a  user, with SUPERUSER privileges, to the sreLite2 UserName database.'

ok=yesno(normal'    're_wh' Would you like add a SUPERUSER ','No Yes','N')
say " "
if ok=0 then do
   say " You can add a user with SUPERUSER privileges by editing USERS.IN "
   return 0
end

bugs: nop
 call charout, bold " Enter a username: " normal
 uname=stringin(,23," ",80)
 say " "

 call charout, bold " Enter a password: " normal
 pwd=stringin(,23," ",80)
 say " "

if uname="" | pwd="" then do
    say " missing username or password: please reenter "
    signal bugs
end  /* Do */


/* read users.in, append uname pwd , write it*/
afile=strip(cfgdir,'t','\')||'\USERS.IN'
oof=stream(afile,'c','open')
kk=stream(afile,'c','query size')
new1=uname' 'pwd' SUPERUSER '
if kk=0 | kk='' then do
  oog=charout(afile,new1,1)
  oof=stream(afile,'c','close')
end 
else do
  new1='0d0a'x||new1
  oof=charin(afile,kk,1)
  if oof='1a'x then kk=kk-1
  kk=kk+1
  afr=stream(afile,'c','seek 'kk)
  oog=charout(afile,new1)
  oof=stream(afile,'c','close')
end 
say " A SUPERUSER has been added, with: "
say bold uname normal " for the username, and " bold pwd normal " for the password "
return 1



/* ----------------------------------------------------------------------- */
/* HOST -- return the result of a HOST command  (a ping )                  */
/* ----------------------------------------------------------------------- */
  host: procedure
   parse arg eek
    do queued(); pull .; end                   /* flush */
    address cmd '@host' eek '| rxqueue'     /* execute the command */
    parse pull hostresult                      /* get result */
    return hostresult



/* -------------------- */
/* choose between 3 alternatives (by default,a yes or no ),
return 1 if yes (or 0,1,2 for chosen altenative ) */

yesno:procedure expose normal reverse bold cy_ye     mm0a listfile
parse arg amessage , altans,def,arrowok
ony2:
aynn=' '
if def='' then
 defans=''
else
 defans=translate(left(strip(def),1))
if altans='' then altans='No Yes'

w.0=words(altans)
goo=aynn
do iw0=1 to w.0
     w.iw0=strip(word(altans,iw0))
     a.iw0=translate(left(w.iw0,1))
     aa.iw0=substr(w.iw0,2)
     aynn=aynn||bold
     if  a.iw0=defans then aynn=aynn||cy_ye
     aynn=aynn||a.iw0||normal||aa.iw0
     goo=goo||a.iw0||aa.iw0
     if iw0<w.0 then do
       aynn=aynn'  '
       goo=goo||'  '
     end
end
if arrowok=1 then aynn=aynn||' [UP]'

do forever
 foo1=normal||reverse||amessage||'? '||normal||aynn||': 'normal
 goo=amessage'?'||goo':'

 if length(goo)<73 then do
    call charout,foo1
 end
 else do
    foo1=normal||reverse||amessage||'? '||normal
    say foo1
    call charout,'     : 'aynn||': 'normal
 end

 anans=translate(sysgetkey('echo'))

 ianans=c2d(anans)
 if anans='' | ianans=13 | ianans=10 then  anans=defans

 if arrowok=1 & ianans=0  then do
     ians=c2d(sysgetkey('noecho'))
     if ians=72 then  do
           say ;say
           return -1  /* -1 : up key */
     end
 end /* do */

 do ijj=1 to w.0
    if abbrev(anans,a.ijj)=1 then do
        say
        return Ijj-1
    end
 end /* do */
 call charout,'0d'x
end




/* ------------------------ */
/* ask for directory name,use defname2 as default */
/* give user opportunity to create it */

get_dir:procedure expose normal reverse bold re_wh
/* procedure expose reverse normal bold */
parse arg defname2 , mustsub
defname0=defname2

n2:
call charout ,  reverse ' <ENTER>=' defname2  normal ' ?'
pull godir

if godir=" " then godir=defname2
if godir="n.a." then signal n2


if mustsub<>"" then do    /* check 'must be subdirectory' option */
  if abbrev(godir,mustsub)=0 then do
     say " This directory MUST be under the " mustsub " directory! "
     say "  .. please re enter ! "
     signal n2
  end
end

godir=strip(godir,'t','\')
gdname=godir||"\*.*"


isme=directory()

isnew=directory(godir)
if isnew="" then do
   say "    Could not find  " godir
   if yesno(normal"        "re_wh"Would you like to create it")=1 then do
        oo=sysmkdir2(godir)
        if oo=0  then do
           say "      Directory created: " godir
        end
        else do
           say "      Could not create " godir "(error = " oo
           if godir=defname2 then defname2= "n.a."
           signal n2
        end
   end
   else do
        say " please reenter directory name ... "
        if godir=defname2 then defname2= "n.a."
        signal n2
   end
end  /* Do */


isme=directory(isme)



return godir

/* ------------- */
sysmkdir2:procedure
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
   if hoo=0 then say ' ... creating: 'dd2  
end /* do */

return hoo


/* ------------- */
/* ----------------------------------------------------------------------- */
/* REPLACESTRG: In string astring, find first occurence substring target and
.   replace it with substring putme
.      if no target, return unchanged astring
.      if no putme, then remove target
.      if type=backward, then find/change LAST occurence
.      if type=all, find/change all occurences
.      if exactmatch=yes, then do not capitalize during search (exact match only */
/* ----------------------------------------------------------------------- */

replacestrg: procedure

exactmatch=0
backward=0 ; doall=0

parse arg astring ,  target   , putme , type , exactmatch

type = translate(type)
if type="BACKWARD" then backward="YES"
if type="ALL" then doall="YES"

iat=1
joelen=length(target)
joelen2=length(putme)

doagain:                /* here if doall=yes */
 if exactmatch="YES" then do
    if   backward="YES" then
        joe= lastpos(target,astring)
    else
        joe= pos(target,astring,iat)
 end
 else do
   if   backward="YES" then
        joe= lastpos(translate(target),translate(astring))
    else
        joe= pos(translate(target),translate(astring),iat)
 end
 if joe=0 then
         return astring

 astring=delstr(astring,joe,joelen)
 if putme<>' ' then
    astring=insert(putme,astring,joe-1)

 if doall="YES" then do
     iat=joe+joelen2
     signal doagain
 end
/* else, all done */
 return astring

/* ----------------------------------------------------------------------- */
/* GRAB_FILE read in a file, but first check to see if openable, and if
.   openable, open and read it.
.    Returns with the file, or with 0 if file not obtainable.
.    Note that file is closed before returning
.   in,
.    usage:   afile_string=grab_file(the_file,seconds_to_try_for)
*/
/* ----------------------------------------------------------------------- */


grab_file: procedure

parse arg afile

ause=stream(afile,'c','open read')
if ause<>"READY:" then
  return 0

goo=charin(afile,1,chars(afile))
ause=stream(afile,'c','close')

/* get rid of ending ctl-z */
if c2d(right(goo,1))=26 then
  goo=left(goo,length(goo)-1)

return goo


/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose  reverse bold normal re_wh
parse arg file1, dest1 , amess , noask
dest2=strip(dest1,'t','\')||'\'
filename=dest1
if pos('.',dest1)=0 then filename=dest2||file1


aa=sysfiletree(filename,isit,'F')
ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno(" Do you want to copy this file (or files) anyways? ")
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if noask=1 then signal doit3

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ")
      if ok=1 & amess<>""  then ok=yesno(amess)
  end
  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ")
      if ok=1 & amess<>""  then ok=yesno(amess)
  end  /* Do */
end
if ok=0 then return 0

doit3:          /* jump here if noask=1 */
'COPY ' file1 dest1 ' > NUL '

return 1




 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC




/* get the hostname (aa.bb.cc) for this machine */
get_hostname: procedure expose re_wh
    do queued(); pull .; end                   /* flush */
    address cmd '@hostname | rxqueue'

    parse pull hostname
    return hostname



/******/
get_SRE2003_dir:

call lineout, bold  " What is SRE2003's "working" directory? " normal
say "    *  The sreLite2 program files will be copied to a subdirectory "


n1:
godir=get_dir(defname)

if godir=" " then godir=defname
if godir="n.a." then signal n1

godir=strip(godir,'t','\')
gsname=godir||"\SRE2003.CMD"

call sysfiletree gsname,gname2,'F'
if gname2.0=0 then do
   say
   say " Note: SRE2003.CMD is not currently installed in "godir
   foo=yesno("Are you sure you this is correct? ",,'Y')
   if foo=0 then exit
   say
end  

return 0

/**********/
get_www_dir:

say " "
call lineout, cy_ye" + + + + "normal BOLD " What is your data directory ?" normal
say  '    .. this is  the location of your "home page" document. '

datadir=get_dir(defname2)

return 0

/*********/
get_ip_address:
say "What is your IP address (it will be given OWNERS status)"
ipaddr=" "
thishost=get_hostname()
sagain:
call charout , BOLD "What is your IP address (ENTER="thishost "):? " normal
pull youraddr
if youraddr=' ' then youraddr=thishost

parse var youraddr t1 '.' .
isnum=0
if  datatype(t1)='NUM' then
  isnum=1
say " wait while that address is checked ... "
chk=host(youraddr)
if translate(word(chk,2))<>"IS" &  word(chk,2)<>"=" then do
    call lineout,re_wh " Unable to find  address: " youraddr normal
    say "    OWNER variable not assigned (but you can assign it later)"
    ipaddr=" "
end  /* Do */
else do
   if isnum then
     ipaddr=word(chk,1)
   else
     ipaddr=word(chk,3)

   say " Your IP address: " ipaddr
end
return 0

/***************/
init_it:

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

nowdir=directory()

initfilt_file=''
echo off


/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  call RxFuncAdd "SockLoadFuncs","rxSock","SockLoadFuncs"
  call SockLoadFuncs
end

thishost=' '


parse version  atype .
if atype<>"REXXSAA" then do
 say    " WARNING: sreLite2 is designed to work under Classic Rexx "
 say     " In particular, it does NOT work under Object Rexx. "
 say     " Other versions of REXX, such as Quercus's REXX, have not been tested."
 say " Note: You are using REXX version: " atype
 say " (hit ENTER to continue) "
  pull .
end  /* Do */


/*---- load the rexxlib library */
droprxlib=0 ; gotrxlib=1
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 droprxlib=1 ; gotrxlib=0
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
    say " Could not find the REXXLIB procedure library (REXXLIB.DLL). "
    say "  Did you download it? "
    exit
end  /* Do */

if rxfuncquery('sref_fileread')<>0 then do
  ik=rxfuncadd('sref_fileread','rexxlib','LIB_FILEREAD')
  if ik<>0 then call pmprintff(' Warning: unable to register SREF_FILEREAD')
end

ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
cyanon=cy_ye
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

/* some defaults */
    datadir="your SRE2003 Data-directory"
    workdir="your SRE2003 Working-directory"
   workdir_notset=1
    helpdir='the SRELITE2 subdirectory of the SRE2003 Data-directory'
    useindex='  '


return 0


/*********/
check_macro:
if macroquery('SREL2_RESET')<>"" then do
     say " "
     say bold "A prior version of the sreLite2 macrospace procedures"normal
     say " were detected. We recommend clearing macrospace before you install sreLite."
     say " However, this might adversely impact other programs (that may also "
     say " use REXX's macrospace). "
     ok=yesno(" Clear macrospace now (Y) ?")
     if ok=1 then do
        say " .... clearing macrospace "
        foo=macroclear()
        say " "
     end  /* Do */
     else do
          say " "
          say  bold " Macrospace will not be cleared. " normal
          say " "
     end  /* Do */
end  /* Do */
return 0


/************/
make_def_dirs:
    adir=filespec("drive",nowdir)

/* can we use values from a recent SRE2003 install */
   a=value('SREINSTALL_SRE2003_DIR',,'os2environment')
   if a<>'' then do
    defname=a
   end 
   else do
      defname=adir||'\SRE2003'
   end


   a=value('SREINSTALL_WWW_DIR',,'os2environment')
   if a<>'' then do
      defname2=a
   end 
   else do
      defname2=adir||'\WWW'
   end

say ' '
    call get_SRE2003_dir        /* but ask for a few directories */
    call get_www_dir

    gosds='SRELITE2 SRELITE2\TEMP SRELITE2\CGI-BIN SRELITE2\ADDON SRELITE2\ADDON\SYSTEM SRELITE2\CFG SRELITE2\CFG\OLD SRELITE2\LOG SRELITE2\DATA '
    wwwds='SRE2K\SRELITE2 SRE2K\SRELITE2\IMGS '

   say "The following sub directories will be created... "
   if length(gosds)<60 then do
      say  "    under "bold||godir||normal " : " gosds
   end
   else do
      ww=words(gosds)
      ww1=trunc(ww/2.5)
      t1=subword(gosds,1,4)
      t2=subword(gosds,5,3)
      t3=subword(gosds,8)

      say  "    under "bold||godir||normal " : " t1
      say  "                  ... " t2
      say  "                  ... " t3

   end 
   say  "    under "bold||datadir||normal" : "wwwds


    workdir=godir
    srelite2_dir=workdir'\srelite2'
    addon_dir=workdir'\srelite2\addon'
    data_dir=workdir'\srelite2\data'

    sysaddon_dir=workdir'\srelite2\addon\system'

    cfgdir=workdir||'\srelite2\CFG'
    cgibin_dir=workdir||'\srelite2\cgi-bin'
    tempdatadir=workdir'\srelite2\temp'
    logdir=workdir'\srelite2\log'

    gifdir=datadir'\sre2k\srelite2\imgs'
    helpdir=datadir'\sre2k\srelite2'

    workdir_notset=0
    do ii=1 to words(gosds)
       a1=strip(word(gosds,ii))
       mdd=workdir'\'a1
       if dosisdir(mdd)=0 then do
          oo=sysmkdir2(mdd)
          if oo<>0 then do 
            say 'ERROR 1: Could not create 'mdd ', error code= ' oo
            exit
         end /* do */
       end
    end /* do */
    do ii=1 to words(wwwds)
       a1=strip(word(wwwds,ii))
       mdd=datadir'\'a1
       if dosisdir(mdd)=0 then do
          oo=sysmkdir2(mdd)
          if oo<>0 then do 
            say 'ERROR 2: Could not create 'mdd ', error code= ' oo
            exit
          end /* do */
       end
    end /* do */
return 1



/********************/
append_file:procedure
parse arg filename,astring,ntries,addcrlf

if ntries='' | ntries=0 then ntries=1
isnew=0

fulln=stream(filename,'c','query exists')

if fulln<>'' then do    /* does exist, get size */
 do ll=1 to ntries               /* sometimes file exists but hasn't been written */
   asize=stream(fulln,'c','query size')
   if asize=''  then do
     if ll=ntries then  return '-1 '||filename' problem reading size '
     call syssleep(1)
     iterate
   end
   leave
 end
end
else do
   fulln=filename               /* create file */
   isnew=1
end

/* now open it */
do jj=1 to ntries
   astat=stream(fulln,'c','open')
   if abbrev(strip(translate(astat)),'READY')=0 then do
     if jj=ntries  then  return '-1 '||fulln' could not be opened'
     call syssleep(1)
     iterate
   end
   leave
end
  
/* if no such file, create it now */
if isnew=1 | asize=0  then do
   if addcrlf=1 then astring=astring||'0d0a'x
   foo=charout(fulln,astring,1)
   foo2=stream(fulln,'c','close')
   if foo<>0 then return '-2 unable to write 'foo' bytes '
   asize=length(astring)
   return asize
end

/* now get last 3 characters  */
iat=asize-2
toget=3
if iat<3 then do 
   toget=1   /* just look for 1a */
   iat=asize
end
aa=charin(fulln,iat,toget)

iwrite=asize+1          /* where to write astring */

checkcrlf=addcrlf
if toget=1 then do      /* just check 1a */
  if aa='1a'x then iwrite=asize
  checkcrlf=0
end 
else do         /* check last char for 1a */
  if right(aa,1)='1a'x then do
     iwrite=asize
     aa=left(aa,2)
  end 
  else do
    aa=right(aa,2)      /* no 1a, so check last two chars for crlf */
  end 
end 

if checkcrlf=1 then do
  if toget=3 then do      /* look for termainating crlf */
    if aa<>'0d0a'x then astring='0d0a'x||astring
  end
end
if addcrlf=1 then astring=astring||'0d0a'x

/* ready to write */

foo=charout(fulln,astring,iwrite)
foo2=stream(fulln,'c','close')
if foo<>0 then return '-2 problem writing 'foo' bytes '
asize=length(astring)+iwrite-1
return asize


