/* This is the STATUSL addon for sreLite2
     Use /statusl? to invoke this addon.
*/

statusl:

parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,user,privset,,
          uri,host_nickname,id_info

if verb=" " then do
   say "This SRELite2 procedure is not meant to be run in standalone mode "
   exit
end  

list0=list
list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

/* first "parse" the parameter list, and store in a simple stem variable */
m=0
optname.=0
list0=list
do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) ; aval=strip(aval)
    if aval='' then aval=1
    avar='!'avar
    optname.avar=aval
end


if optname.!PARAMS=1  then do

   stuff=srel2_get_userinfo(,,host_nickname,id_info)  /* lookup in users.in database */
   if stuff<>'' then do          /* pull out privs */
     parse var stuff username pwd privset1
     privset=privset' 'privset1' USER'         /* users in userfile always give a USER privilege */
   end


  if srel2_check_privs('SUPERUSER',privset)=0 then do
      rcode=sre_auth_response('View Status',servername,, ,
        'You need SuperUser privilieges to view parameter settings', ,
         id_info)
     return rcode
   end
end 



/* Information will be returned in a temporary file, whose name
   is provided in the tempfile variable.
   Note that it's a good idea to start your HTML documents with a dtd doctype statement
*/

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
nowtime=sre_datestamp()
call lineout tempfile,'<em>Current time is 'nowtime'</em><br>'
call lineout tempfile, "<html><head><title>Results from a /statusl?  request</title>"
call lineout tempfile, "</head><body>"

call lineout tempfile,' <h2>Results from  a /statusl? request </h2>'

call lineout tempfile,' <h3>The arguments recieved by the statusl addon </h3> '

call lineout tempfile,' <dl> '

  call lineout tempfile,' <dt>  LIST  <dd><code>' list0 ' </code> '

  call lineout tempfile,' <br> LIST is read from:</b>: '
     call lineout tempfile, '<br> ... if POST method, from the <code>body</code> of the request '
     call lineout tempfile,' <br> ... if GET method ,  from after the "?" in the request string.  '

   call lineout tempfile,' <dt>  SERVERNAME <dd> <code>' servername '</code> '

   call lineout tempfile,' <dt>  VERB <dd> <code>' VERB ' </code> '

   call lineout tempfile,' <dt>  TEMPFILE <em> The "temporary file" (used to build this response)</em> ',
                         '<DD> <code>' tempfile ' </code> '

   call lineout tempfile,' <dt> PROGFILE <em> The file containing this addon </em><DD> <code> ' prog_file '</code>'

   call lineout tempfile,'<dt>REQNUM '
      call lineout tempfile,'<Em>The transaction and request within transaction </em>'
     call lineout tempfile,'<dd><code> 'reqnum '</code>'
 
   call lineout tempfile,'<dt>VERBOSE <dd> <code>'verbose'</code>'

   call lineout tempfile,' <dt> CLIENT <em> Client''s ip address </em>'
     call lineout tempfile,'<dd> <code>' user ' </code> '

   call lineout tempfile,' <Dt> PRIVSET <em> Your username specific privileges </em> '
        call lineout tempfile,'<dd> <code> ' privset ' </code> '

   call lineout tempfile,' <dt>  URI <em> The full <b>request string</b></em> '

   call lineout tempfile,'<dd> <code>' URI ' </code> '
 
   call lineout tempfile,' <Dt> HOST_NICKNAME '
            call lineout tempfile,' <DD> <code> ' host_nickname ' </code> '

call lineout tempfile,' </dl> '


call lineout tempfile,' <h3>Other useful parameters </h3> '
ddir=sre_datadir()
workdir=sre_value('SREL2_TEMP_DIR',,'SRE')
addon_dir=sre_value('ADDON_DIR',,'SRE')
homedir=sre_value('HOME_DIR',,'SRE')
srvdir=sre_value('SRV_DIR',,'SRESYS')
filterdir=sre_value('FILTER_DIR',,'SRESYS')

call lineout tempfile,' <dl> '

   call lineout tempfile,' <dt>  DATADIR = <code>' ddir '</code> '
     call lineout tempfile,' <dd>  The "data directory" (where your HTML documents should be) '

   call lineout tempfile,' <dt>  SRV_DIR = <code>' srvdir ' </code> '
      call lineout tempfile,' <dd> The "working directory" (where SRE2003 lives) '

   call lineout tempfile,' <dt>  FILTER_DIR = <code>' filterdir ' </code> '
      call lineout tempfile,' <dd> The "filter directory" (where sreLite2 lives) '

   call lineout tempfile,' <dt>  SREL2_TEMP_DIR = <code>' workdir ' </code> '
      call lineout tempfile,' <dd>  Temporary area, for working files '

   call lineout tempfile, '<dt> HOME_DIR=<code> ' homedir  ' </code>'
     call lineout tempfile,' <Dd> The ~ (home directory) string '

call lineout tempfile,'</dl>'

/* Read the "header" -- and display the results */
foo=sre_command('READ HEADER')
call lineout tempfile,' <h3> The Request Header </h3> '
call lineout tempfile,' <blockquote> <pre>'||foo||'</pre> </blockquote>'

call lineout tempfile,' <h3> Some User &amp; Server Info </h3> '
caddr=sre_extract('CLIENTADDR')
cname=sre_clientname()
ssoft=sre_server('NF')
saddr=sre_extract('SERVERADDR')
sport=sre_extract('SERVERPORT')

call lineout tempfile,' <ul> '
   call lineout tempfile,' <li> Client ip address:  <code>' caddr '</code>'
   call lineout tempfile,' <li> Client name:  <code>' cname '</code>'
   call lineout tempfile,' <li> Server ip address: <code>' saddr '</code>'
   call lineout tempfile,' <li> Server port:  <code>' sport '</code>'
   call lineout tempfile, ' <li> Server software:  <code>' ssoft '</code>'
call lineout tempfile,' </ul> '


getuse: nop
/* get some "intensity of use " statistics */
 reptime=sre_extract('RESPONSETIME')
 numtrans=sre_extract('TRANSACTIONS')
 whenstart=sre_extract('LASTSTART')
 nclients=sre_extract('CLIENTS')

 call lineout tempfile,' <h3> Use Statistics </h3> '

 call lineout tempfile,' SRE2003 started: ' whenstart
 call lineout tempfile,'<BR> # of transactions ' numtrans  ', avg. reponsetime = 'reptime ' sec. '
 call lineout tempfile,'<BR> Current # of clients = ' nclients


/* Special features (such as the HOST function) -- demonstrates the use of external calls */
 

/* if we found a GETIP, and got it's value, then lookit up */
  if optname.!GETIP<>0  then do
/* Note use of the address cmd xxx to call a OS/2 level command  */
    A=RXQUEUE('S','SESSION')    /* SINCE QUEUE MIGHT BE A THREAD'S QUEUE */
    do queued(); pull .; end                   /* flush */
    chkip=optname.!GETIP
    address cmd '@host' chkip '| rxqueue'     /* execute the command */
    parse pull hostresult                      /* get result */
    call lineout tempfile,' <h3> Look up address </h3> '
    call lineout tempfile,' <pre> ' hostresult ' </pre>'
  end

  call lineout tempfile,'<h3>SuperUser options:</h3>'
  call lineout tempfile,'<b>SuperUsers</b> can:<menu>'
  call lineout tempfile,'<li> <a href="/!RESET">reset sreLite2 parameters</a>'
  call lineout tempfile,' <li> View  <A href="/statusl?params=1">parameter settings</a>'
  call lineout tempfile,'</menu>'

if optname.!PARAMS=1  then do           /* if this is true, must be  superuser */
    call show_params
end 


/* all done, write final end-of-html elements */
  call lineout tempfile,'<body> </html>'
  call lineout tempfile
  rcode=sre_command('FILE ETAG_AUTO EXPIRES 30s NOCACHE NOIF ERASE TYPE text/html NAME 'tempfile,,id_info)
  return rcode


/********/
/* show sre-lite parameters  (maybe add "change parameters" option later)

   These variables are user-changable parameters hard-coded into
   SREL_INI.RXX
       SREL2_TEMP_DIR    SREL2_CFG_DIR  SREL2_LOG_DIR SREL2_INITFILE
       CGIBIN_DIR    ADDON_DIR    USERFILE COMMON_LOG_FILE
       DIGEST_AUTH  EMPTY_PATH_OK  ENABLE_HTTP11  PROXY_CACHE  
       ADD_SLASH  INTERPRET_TYPES

   These are set in SRELITE2.CFG
     ACCEPT_RANGE ALWAYS_GET_PRIVS ADD_SLASH DEFAULT_REQUIRES DEFAULTS
     DIR_EXCLUSION GZIP_THESE HOME_DIR LOGIT NOT_FOUND_FILE POST_FILTER
     SSI_EXTENSIONS REALM  SUPERUSERS VERBOSE
     and some "stemp" vars
     ALIASES INHOUSEIPS SEL_REQUIRES
*/
show_params:

call lineout tempfile,' <hr><h3>Current parameter settings </h3> '
ofo=''

os2e='os2environment'
params1=' SREL2_TEMP_DIR  SREL2_CFG_DIR  SREL2_LOG_DIR SREL2_INITFILE ',
       'CGIBIN_DIR    ADDON_DIR    USERFILE COMMON_LOG_FILE'

params2='DIGEST_AUTH EMPTY_PATH_OK ENABLE_HTTP11 PROXY_CACHE ADD_SLASH INTERPRET_TYPES'

params3='ACCEPT_RANGE ALWAYS_GET_PRIVS ADD_SLASH DEFAULT_REQUIRES DEFAULTS ',
     'DIR_EXCLUSION GZIP_THESE HOME_DIR LOGIT NOT_FOUND_FILE POST_FILTER ',
     'SSI_EXTENSIONS REALM  SUPERUSERS VERBOSE '

call lineout tempfile,' <hr>Hard-coded parameters  '

call lineout tempfile,'<ul>'
do mm=1 to words(params1)
  aw=strip(word(params1,mm))
  aa=sre_value(aw,,'SRE')
  Call lineout tempfile,'<li>'ofo||' '||aw '= <tt>'aa'</tt>'
end
call lineout tempfile,'</ul><br>'

call lineout tempfile,'<ul>'
do mm=1 to words(params2)
  aw=strip(word(params2,mm))
  aa=sre_value(aw,,'SRE')
  Call lineout tempfile,'<li>'ofo||' '||aw '= <tt>'aa'</tt>'
end
call lineout tempfile,'</ul>'

/* now do non-stem srelite2.cfg vars */

cfgfile=sre_value('SREL2_INITFILE',,'SRE')
call lineout tempfile,' <hr>Parameters in 'cfgfile
call lineout tempfile,'<ul>'
do mm=1 to words(params3)
  aw=strip(word(params3,mm))
  aa=sre_value(aw,,'SRE')
  Call lineout tempfile,'<li>'ofo||' '||aw '= <tt>'aa'</tt>'
end

/* now do stem srelite2.cfg vars: SEL_REQUIRES, INHOUSEIPS, ALIASES */

ii=sre_value('ALIASES',,'SRE')
call lineout tempfile,'<li># of aliases= 'ii
if ii>0 then do
   allaliases=sre_value('ALIASES',,'SRELARGE')
   call lineout tempfile,'<PRE>'allaliases'</pre>'
end 

ii=sre_value('INHOUSEIPS',,'SRE')
call lineout tempfile,'<li># INHOUSE IP addresses= 'ii
if ii>0 then do
   allin=sre_value('INHOUSEIPS',,'SRELARGE')
   call lineout tempfile,'<PRE>'allin'</pre>'
end 

ii=sre_value('SEL_REQUIRES',,'SRE')
call lineout tempfile,'<li># of SEL_REQUIRES= 'ii
if ii>0 then do
   allsel=sre_value('SEL_REQUIRES',,'SRELARGE')
   call lineout tempfile,'<PRE>'allsel'</pre>'
end 
call lineout tempfile,'</ul><p>'


/* call lineout tempfile,'<input type="submit"><input type="RESET"></form><p>'*/
call lineout tempfile,'Would you like to view the <a href="/SRE2k/srelite2/srelite2.htm" target="MANUAL2"> sreLite2 manual?</a>'
call lineout tempfile,'<br>Or, return to the <a href="/">home page</a> <br>'
return 1



