/* an srelite2 addon to configure the SRE2003.cfg parameter file  */
sre2kcfg:

USECOLOR='2dd52f'

/* ---------------- DO NOT MODIFY BELOW THIS LINE  ------------------ */


/* parse arg ddir,tempfile,sel,list,verb,uri,user,basedir,workdir,privset,
        enmadd,transaction,verbose   */

parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,user,privset,,
          uri,host_nickname,id_info

if verb="" then do
   say " This sreLite2 add-on is NOT meant to be run from the command line."
   exit
end  

ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote (not-from-server-machine) web access to configuration utilities not permitted.',,id_info)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",id_info)
    who=sre_extract("serveraddr",id_info)
    if myaddr<>who then do
      sfoo=sre_command('String External access to configuration utilities is not permitted' ,,id_info)
      return sfoo
   end
end


signal on error name foo1 ; signal on syntax name foo1


crlf='0d0a'x
list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */


list=strip(list)
if pos('TODO=_MODIFY',sre_pACKUR(list))>0 then signal modifyit

/*  ======= show form of values */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2: view and modify SRE2003 parameters </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile,'<script language="javascript">'
call lineout tempfile,'var VU_OPEN=0;'
call lineout tempfile,'function Vu_doc(aloc) {'
call lineout tempfile,' if (VU_OPEN==0) {'
call lineout tempfile,'    daVIEWTREE=window.open("/sre2k/SRE2003.htm","SRELITE2_DOC", "location=NO,MENUBAR=NO,RESIZABLE,DEPENDENT,SCROLLBARS=YES,STATUS=YES,TITLEBAR,TOOLBAR=NO,SCREENX=212,SCREENY=30,height=300,width=700");'
call lineout tempfile,'  };'
call lineout tempfile,'  VU_OPEN=1; daVIEWTREE.focus() ; '
call lineout tempfile,'  daVIEWTREE.location.hash=aloc ;'
call lineout tempfile,' return false ;}'
call lineout tempfile,' '
call lineout tempfile,' </script>'

call lineout tempfile, "<h2> sreLite2: view and modify SRE2003 configuration parameters   </h2> <p>"

inifile=sre_value('SRE2003_CFG',,'SRESYS')
datetime=stream(inifile,'c','query datetime')
call lineout tempfile,'<em>' inifile ' last modified on 'datetime '</em><br>'
call lineout tempfile,'<FORM method="POST" action="/system/sre2kCFG">'
call lineout tempfile,'<Input type="hidden" name="TODO" value="_MODIFY">'
call lineout tempfile,'<TABLE border=1><TR><th>Check to<br>modify</th><TH>Parameter</th><th>current value</th>'

/* get parameters from file */
call get_parameters inifile

call lineout tempfile,'<tr>'
dolist=params.0
do forever
   if dolist='' then leave
   parse var dolist avar dolist
   avar=strip(avar)
   aa='!'avar
   aval=params.aa
   call lineout tempfile,'<tr><td><input type="checkbox" name="MODIFY" value="'avar'"></td>'
   goo=lower(space(translate(avar,' ','_'),0))
   lavar=make_link(avar)

/* '<a href="/sre2k/SRE2003.htm#cfg'||goo||'" target="SRELITE2_DOC">'avar'</a>'  */

   call lineout tempfile,'<td>'lavar'</td>'
   oo=make_cell(avar,aval)
   call lineout tempfile,'<td>'oo'</td>'
end /* do */


call lineout tempfile,'</table> '

call lineout tempfile,'<input type="SUBMIT" value="Modify SRE2003 Parameters"><input type="RESET"></form>'

call lineout tempfile,' <a href="/sre2k/SRE2003.htm#configuring" '
call lineout tempfile,'  onCLick="Vu_doc(''configuring'');  return false " '
call lineout tempfile,'  onMouseOut="window.status=''Configure SRE2003 parameters'' ; return true "  '
call lineout tempfile,'  onMouseOver="window.status=''View SRE2003 documentation in separate window'' ;return true">'
call lineout tempfile,'  Description of SRE2003 parameters</a> || '
call lineout tempfile,'<a href="/sre2k/srelite2/config.htm" >Return&nbsp;to&nbsp;sreLite2&nbsp;configuration&nbsp;page</a>'


call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
return foo



/*=====  MODIFY (2nd step), given response from a form  */
modifyit:
call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2: modifying SRE2003 parameters </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite2: modifying SRE2003 parameters        </h2> <p>"

/* get parameters from file */
call get_parameters

/* get parameters sent by the client. Note: only change those marked as MODIFY */
modlist=''
vals.=''
do until list=''
   parse var list a1 '&' list
   parse var  a1 avar '=' aval ;avar=strip(translate(avar))
   AVAL=sre_PACKUR(TRANSLATE(AVAL,' ','+'||'0D0A'X))
   if avar='MODIFY' then do 
       taval=strip(translate(aval))
       if wordpos(taval,modlist)=0 then modlist=modlist' '||tAVAL
   end 
   else do
     avarx='!'avar
     vals.avarx=vals.avarx||' '||aval
   end 
end 

/*No changes ?? */
if modlist='' then do
   call lineout tempfile,' No parameters were modified -- parameter file ('inifile') was not  changed'
   call lineout tempfile,'<p><a href="/system/sre2kCFG?todo=SHOW">Redisplay parameters file </a> <tt>(you may have to use <tt>reload</tt>)'
   call lineout tempfile
  foo=sre_command('FILE EXPIRES 5s NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
  return foo
end 

/* Create a backup */

oo=filespec('d',inifile)||filespec('p',inifile)||'OLD'
if dosisdir(oo)=0 then
  oo=filespec('d',inifile)||filespec('p',inifile)
oo=strip(oo,'t','\')||'\SRE2003.???'

toydog=dostempname(oo)
foo=dosrename(inifile,toydog)

if foo=1 then do
  call lineout tempfile,'<p>Old <tt>'inifile'</tt> moved to <tt> 'toydog '</tt>'
end
else do
  call lineout tempfile,'<p>Error. Could not rename old <tt> 'inifile '</tt> to <tt>'toydog'</tt>'
  call lineout tempfile,'</body></html>'
  call lineout tempfile
  foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
  return foo
end

didlastmod=0
didlist=''
oldmodlist=modlist
/* modify values... -- check each line in old inifile */

do mm=1 to lins.0
  alin=strip(lins.mm)
  if alin='' | abbrev(alin,';')=1 then do
     if abbrev(alin,';last-modified:')=1 then do
        alin=';last-modified: '||date('n')||' '||time('n')
        didlastmod=1
     end 
     call lineout inifile,alin
     iterate
  end 
  parse var alin avar0 '=' aval0
  avar0=strip(translate(avar0))
  if wordpos(avar0,didlist)>0 then iterate  /* SKIP repeated entries */

/* if not in MODIFY list, then write out current value (ignore value send
   by client */
  ido=wordpos(avar0,modlist)
  if ido=0 then do
     call lineout inifile,alin
     iterate
  end 
/* write out using new value (the one sent by the client */
  avarx='!'avar0
  vv=vals.avarx
  if vv='' then do
      call lineout inifile,avar0 ' = '||vv
  end
  else do
    do until vv=''
      parse var  vv avv '0d0a'x vv
      if avv<>'' then call lineout inifile,avar0 ' = '||avv
    end
  end
  didlist=didlist' 'avar0   /* used to SKIP repeated entries */
  modlist=delword(modlist,ido,1)  /* this has been modified */
end /* do */


call lineout tempfile,'<p> '||words(oldmodlist)||' parameters were modified: '
call lineout tempfile,'<blockquote><tt>'||oldmodlist||'</tt></blockquote>'


/* these are items that were chosen to be modified by the client, but
   that did not exist in the inifile. So write them out now. */

if modlist<>'' then do
   call lineout inifile,'; new additions on 'date('n')
   do forever
       if modlist='' then leave
       parse var modlist avar modlist
       avar0=strip(avar)
       avarx='!'avar0
       call lineout inifile,avar0 ' = '||vals.avarx 
   end
end 

if didlastmode=0 then do
     call lineout inifile,' '
     alin=';last-modified: '||date('n')||' '||time('n')
     call lineout inifile,alin
end


call lineout inifile
foo=sre_flag_set('RESET',1)

call lineout tempfile,'<p><b>'inifile' </b> succesfully created'
call lineout tempfile,'<p><a href="/system/sre2kCFG?todo=SHOW">Redisplay parameters file </a> <tt>(you may have to use <tt>reload</tt>'
call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
return foo


/***************/
/* load entries.!user .!pwd and .!privs */
get_parameters:
parse arg inifile

if inifile='' then inifile=sre_value('SRE2003_CFG',,'SRESYS')

stuff=sre_read_file(inifile,2,2)

inhouseips.0=0 ; sel_requires.0=0 ; aliases.0=0
crlf='0d0a'x
params.=''
lins.0=0;ill=0
do forever
   if stuff='' then leave
   parse var stuff aline (crlf) stuff
   ill=ill+1
   lins.ill=aline
   lins.0=ill
   aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline  avar '=' aval
   avar=space(translate(avar),0)
   aval=strip(aval)
   if avar='' then iterate      /* bad value */
   if aval='' then aval="' '"
   a1=left(aval,1)
   if a1='"' | a1="'" then aval=strip(aval,,a1)
   aa='!'avar
   if params.aa<>'' then
      params.aa=params.aa||'0d0a'x||aval
   else
      params.aa=aval

    if wordpos(avar,params.0)=0 then params.0=params.0' 'avar

end

return 1


foo1:
foo=sre_pmprintf("sre2kCFG error at " sigl ' ' rc)
foo=sre_command(string "sre2kCFG error at " sigl ' ' rc,,id_info)


exit



/*****/
/* make a link to doc file, for a param name */
make_link:procedure
parse arg aa
goo='cfg'||lower(space(translate(aa,' ','_'),0))
aloc="'"||goo||"'"
bb='onClick="Vu_doc('||aloc||');  return false " '
na='<a href="/sre2k/SRE2003.htm#'||goo||'" target="SRELITE2_DOC" 'bb'>'AA'</a>'
return na


/*********************/
/* make an input cell */
make_cell:procedure expose id_info
parse arg avarx,avalx
avarx=strip(translate(avarx))
avalx=space(avalx,1)
select

   when avarx='AUDIT_ITEMS' then do
      vvs.=''
      do mm=1 to words(avalx)
         a1='!'||strip(translate(word(avalx,mm)))
         vvs.a1='SELECTED'
      end 
      aa='Select 0 or more of the following options:<table><tr><td> '
      aa=aa||'<SELECT NAME="AUDIT_ITEMS" SIZE="3" MULTIPLE >'
        aa=aa||'<OPTION '||vvs.!CLIENT||' VALUE="CLIENT"  >CLIENT'
        aa=aa||'<OPTION '||vvs.!REQUEST||' VALUE="REQUEST"  >REQUEST'
        aa=aa||'<OPTION '||vvs.!RESET||' VALUE="RESET"  >RESET'
      aa=aa||'</SELECT></td>'
      aa=aa||'<td><SELECT NAME="AUDIT_ITEMS" SIZE="2" MULTIPLE >'
        aa=aa||'<OPTION '||vvs.!SEND||' VALUE="SEND"  >SEND'
        aa=aa||'<OPTION '||vvs.!MESSAGE||' VALUE="MESSAGE"  >MESSAGE'
      aa=aa||'</SELECT><td>'
      aa=aa||'<td><SELECT NAME="AUDIT_ITEMS" SIZE="2" MULTIPLE >'
        aa=aa||'<OPTION '||vvs.!DIAG||' VALUE="DIAG"  >DIAG'
        aa=aa||'<OPTION '||vvs.!DIAG2||' VALUE="DIAG2"  >DIAG2'
      aa=aa||'</SELECT></table>'
   end

   when avarx='AUDIT_DELAY' then do
      aa='Audit-file lazy write in minutes (or fractions of a minute)<br>'
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end


   when avarx='DEFAULT_SOCKET_TIMEOUT' then do
      aa='in seconds  '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end


   when avarx='FAST_FILTER' then do
      aa='a filename, or a 0 to not use a fast filter  '
      aa=aa||'<input type="text" size=30 name="'avarx'" value="'avalx'">' 
   end

   when avarx='IM_TYPES' then do
      aa='Up to 5 pairs of: <tt>im_name1 im_file1 , im_name2 im_file2 , ... </tt>)<br>'
      aa=aa||'<input type="text" size=60 name="'avarx'" value="'avalx'">' 
   end

   when avarx='IM_DEFAULT' then do
      aa='Default IM module (0, RANGE, or an <tt>im_name</tt> from IM_TYPES)<br>'
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end



   when avarx='LIMITHEADER' then do
      aa='in Kbytes '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='LIMITCLIENTS' then do
      aa='(max simultaneous connections) '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when wordpos(avarx,'MAXSTATVALS PORT')>0 then do
      aa='<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when wordpos(avarx,'MAXCLIENTNAMES MAXMD5S')>0 then do
      aa='(set to 0 to disable this cache) '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='MAXCOUNTERS' then do
      aa='(must be > 9) '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='LIMITBODY' then do
      aa='in Kbytes '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='LIMITTIMETOTAL' then do
      aa='in seconds '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='LIMITTIMEWAIT' then do
      aa='in seconds '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='LIMITTIMEINACTIVE' then do
      aa='in seconds (must be less then LIMITTIMETOTAL) '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end


   when avarX='NO_MODIFY_ONTHEFLY' then DO
      AA=make_radios(2,avalx,avarx,0,"On-the-fly-mods OK",1,"NO on-the-fly-mods")
   END


   when avarx='REQ_CACHE_ENABLE' then do
      aa='lifespan of request-cache entries (in days). <nobr> <tt> 0</tt> to disable use of the request cache.</nobr><br> '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end


   when avarx='REQ_CACHE_SIZE' then do
      aa='(in number of entries) '
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='REQ_CACHE_CALL_ANYWAYS' then do
      aa='<b>0</b> do <em>not</em> call filter <br> <b>*</b> or <b>1</b> </b> Always call filter <br>'
      aa=aa||'<b>a_list</b> Call filter if an abbreviation in a_list matches selector <br>'
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end


   when avarX='REQ_CACHE_VERIFY' then DO
      AA=make_radios(3,avalx,avarx,0,"Never",1,"Check Etag, date, pragma and cache-control ",,
                                   2,"<nobr>Check pragma and cache-control</nobr>")
   END

   when avarX='SECURITY_LEVEL' then DO
      AA=make_radios(3,avalx,avarx,0,"No Remote",1,"Only From Server ",,
                                   2,"SUPERUSERS okay")
   END


   when avarx='STATUS_ITEMS' then do
/* LASTACCEPT CONNECTIONS CLIENTS ERRORS CLOCK LIMITS PEAK STATS VERBOSE */

      vvs.=''
      do mm=1 to words(avalx)
         a1='!'||strip(translate(word(avalx,mm)))
         vvs.a1='SELECTED'
      end 
      aa='Select 0 or more of the following options:<table><tr><td> '
      aa=aa||'<SELECT NAME="STATUS_ITEMS" SIZE="3" MULTIPLE >'
        aa=aa||'<OPTION '||vvs.!LASTACCEPT||' VALUE="LASTACCEPT"  >LASTACCEPT'
        aa=aa||'<OPTION '||vvs.!CONNECTIONS||' VALUE="CONNECTIONS"  >CONNECTION'
        aa=aa||'<OPTION '||vvs.!CLIENTS||' VALUE="CLIENTS"  >CLIENTS'
      aa=aa||'</SELECT></td>'
      aa=aa||'<td><SELECT NAME="STATUS_ITEMS" SIZE="3" MULTIPLE >'
        aa=aa||'<OPTION '||vvs.!ERRORS||' VALUE="ERRORS"  >ERRORS'
        aa=aa||'<OPTION '||vvs.!CLOCK||' VALUE="CLOCK"  >CLOCK'
        aa=aa||'<OPTION '||vvs.!LIMITS||' VALUE="LIMITS"  >LIMITS'

      aa=aa||'</SELECT><td>'
      aa=aa||'<td><SELECT NAME="STATUS_ITEMS" SIZE="3" MULTIPLE >'
        aa=aa||'<OPTION '||vvs.!PEAK||' VALUE="PEAK"  >PEAK'
        aa=aa||'<OPTION '||vvs.!STATS||' VALUE="STATS"  >STATS'
        aa=aa||'<OPTION '||vvs.!VERBOSE||' VALUE="VERBOSE"  >VERBOSE'
      aa=aa||'</SELECT></table>'
   end


   when avarX='REQ_CACHE_RECORD' then DO
      aa='<b>0</b> do <em>not</em> record <br> <b>nn</b> record every nn minutes'
      aa=aa||'<input type="text" size=15 name="'avarx'" value="'avalx'">' 
   end

   when avarx='TRACKING_ON' then do
       aa=make_radios(2,avalx,avarx,0,'Disable',1,'Enable')
   end /* do */

   otherwise do
       aa='<Input type="text" name="'avarx'" size=60 value="'avalx'">'
   end
end  /* select */
return aa






/********************************************/
/* --- create a row of radio buttons */
make_radioS:procedure
parse arg ndo,curval,thename
aa=''

do mm=1 to ndo
 MM2=MM*2
 thisval=arg(mm2+3-1)
 thisopt=arg(mm2+3)
 aa=aa||'<input type="radio" name="'thename'" '
 if curval=thisval then aa=aa||' CHECKED '
 aa=aa||'value="'thisval'" >'thisopt' '
 IF MM<NDO then AA=AA||' || '
end /* do */
RETURN AA


